<?php

namespace Kaitek\Bundle\FrameworkBundle\Repository;
//use Kaitek\Bundle\FrameworkBundle\Model\MenuInterface;


use Doctrine\ORM\EntityManager;
use Doctrine\ORM\EntityRepository;
use Kaitek\Bundle\FrameworkBundle\Exception\MenuIdNotFoundException;
use Kaitek\Bundle\FrameworkBundle\Model\MenuLoaderInterface;
use Symfony\Bundle\FrameworkBundle\Translation\Translator;
use Symfony\Component\Translation\DataCollectorTranslator;
/**
 * MenuRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class MenuRepository extends EntityRepository
{
    function __construct($em, $class)
    {
        parent::__construct($em, $class);
        $this->UNRESTRICTED_MENU_IDS = ['logout'];
    }

    public function loadMenuByMenuId($menuId) {
        $menu = $this->createQueryBuilder('m')
            ->where('m.menuId = :menuId')
            ->setParameter('menuId', $menuId)
            ->getQuery()
            ->setMaxResults(1)
            ->getOneOrNullResult();

        /*if (null === $menu) {
            $message = sprintf(
                'Unable to find a menu KaitekFrameworkBundle:Menu object identified by "%s".',
                $menuId
            );
            throw new MenuIdNotFoundException($message);
        }*/

        return $menu;
    }

    /**
     * Makes menu records based on the user's rights.
     *
     *
     * @param EntityManager $em
     * @param bool $af IS_AUTHENTICATED_FULLY
     * @param bool $ru ROLE_USER
     * @param bool $ra ROLE_ADMIN
     * @param DataCollectorTranslator $tr Translate service
     * @param Integer $userId User id value
     *
     * @return MenuInterface|null
     */
    /*
    public function loadUserMenu($em,$af,$ru,$ra,$tr,$userId){
        //$em = $this->_em;
        if (!$af) {
            return array();
        }
        $rsm = new ResultSetMapping;
        $rsm->addScalarResult('id', 'id');
        $rsm->addScalarResult('sira', 'sira');
        $rsm->addScalarResult('parentid', 'parentid');
        $rsm->addScalarResult('menuid', 'menuid');
        $rsm->addScalarResult('title', 'title');
        $rsm->addScalarResult('url', 'url');
        $rsm->addScalarResult('width', 'width');
        $rsm->addScalarResult('height', 'height');
        $rsm->addScalarResult('modulename', 'modulename');
        $rsm->addScalarResult('iconcls', 'iconcls');
        $rsm->addScalarResult('multiplewindow', 'multiplewindow');
        $rsm->addScalarResult('maximizable', 'maximizable');
        $rsm->addScalarResult('resizable', 'resizable');
        $rsm->addScalarResult('mobiledevice', 'mobiledevice');
        $rsm->addScalarResult('aright', 'aright');
        $rsm->addScalarResult('uright', 'uright');
        $rsm->addScalarResult('dright', 'dright');
        $rsm->addScalarResult('uownright', 'uownright');
        $rsm->addScalarResult('downright', 'downright');
        if ($ru && !$ra) {
            //$user = $sc->getUser();
            //$userId = $user->getId();
            $sql="  select _m.id,_m.sira,_m.parentid,_m.menuid,_m.title,_m.url
                            ,_m.width,_m.height,_m.modulename,_m.iconcls
                            ,_m.multiplewindow,_m.maximizable,_m.resizable,_m.mobiledevice
                            ,_a.aright,_a.uright,_a.dright,_a.uownright,_a.downright
                    from (
                            SELECT rr.menu_id,MIN(cast(rr.gright as int))gright,MIN(cast(rr.aright as int))aright
                                    ,MIN(cast(rr.uright as int))uright,MIN(cast(rr.dright as int))dright
                                    ,MIN(cast(rr.uownright as int))uownright,MIN(cast(rr.downright as int))downright
                            from _user u
                            join _user_role r on r.user_id=u.id and r.duser_id is null
                            join _role_right rr on rr.duser_id is null and rr.gright='t'
                            left join _user_right ur1 on ur1.user_id=u.id and ur1.menu_id=rr.menu_id and ur1.duser_id is null
                            where u.locked='f' and u.expired='f' and ur1.id is null and u.id=$userId
                            GROUP BY rr.menu_id
                            UNION all
                            SELECT ur.menu_id,MIN(cast(ur.gright as int))gright,MIN(cast(ur.aright as int))aright
                                    ,MIN(cast(ur.uright as int))uright,MIN(cast(ur.dright as int))dright
                                    ,MIN(cast(ur.uownright as int))uownright,MIN(cast(ur.downright as int))downright
                            from _user u
                            join _user_right ur on ur.user_id=u.id and ur.duser_id is null and ur.gright='t'
                            where u.locked='f' and u.expired='f' and u.id=$userId
                            GROUP BY ur.menu_id
                    )_a
                    join _menu _m on _m.id=_a.menu_id
                    where _a.gright>0 and _m.duser_id is null
                    ORDER BY _m.parentid,_m.sira";

        }
        if ($ra){
            $sql="SELECT _m.id,_m.sira,_m.parentid,_m.menuid,_m.title,_m.url
                    ,_m.width,_m.height,_m.modulename,_m.iconcls
                    ,_m.multiplewindow,_m.maximizable,_m.resizable,_m.mobiledevice
                    ,1 aright,1 uright,1 dright,1 uownright,1 downright
                FROM _menu _m
                where _m.duser_id is null
                ORDER BY _m.parentid,_m.sira ASC";
        }
        $query = $em->createNativeQuery($sql,$rsm);
        $result=$query->getArrayResult();
        $pid=-1;
        $menus=array();
        $j=0;
        for($i=0;$i<count($result);$i++){
            $item=$result[$i];
            $modulename=$item['modulename'];
            $title=$item['title'];
            if($modulename==""){
                $arrtitle = explode(".", $title);
                $domain=$arrtitle[0];
                array_shift($arrtitle);
                $key=implode(".", $arrtitle);
            }else{
                $domain=$modulename;
                if($title==""){
                    $key=$modulename.".title";
                }else{
                    $key=$modulename.".".$title;
                }
            }
            $title=$tr->trans($key, array(), $domain);
            $item['title']=$title;
            if($pid!==$item['parentid']){
                $pid=$item['id'];
                $menus[$j++]=$item;
            }else{
                if(!isset($menus[$j-1]['items'])){
                    $menus[$j-1]['items']=array();
                }
                $menus[$j-1]['items'][]=$item;
            }
        }
        return $menus;
    }
    */

    /**
     * Makes menu records based on the user's rights.
     *
     *
     * @param EntityManager $em
     * @param bool $af IS_AUTHENTICATED_FULLY
     * @param bool $ru ROLE_USER
     * @param bool $ra ROLE_ADMIN
     * @param DataCollectorTranslator $tr Translate service
     * @param int $userId User id value
     *
     * @return array|null
     */
    private function loadUserRightMenu(EntityManager $em, bool $af, bool $ru, bool $ra, $tr, int $userId){
        if (!$af) {
            return array();
        }
        if ($ru && !$ra) {
            $queryrole = $em->createQueryBuilder()
                ->select("IDENTITY(rr.menuId)menuId"
                        . ",MIN(case when rr.gRight='t' then 1 else 0 end)gRight"
                        . ",MIN(case when rr.aRight='t' then 1 else 0 end)aRight"
                        . ",MIN(case when rr.uRight='t' then 1 else 0 end)uRight"
                        . ",MIN(case when rr.dRight='t' then 1 else 0 end)dRight"
                        . ",MIN(case when rr.uOwnRight='t' then 1 else 0 end)uOwnRight"
                        . ",MIN(case when rr.dOwnRight='t' then 1 else 0 end)dOwnRight"
                        . "")
                ->from('KaitekFrameworkBundle:User','u')
                ->join('u.user_roles', 'ur', 'WITH', 'ur.deleteuserId is null')
                //->join('ur.role', 'r', 'WITH', 'r.deleteuserId is null')
                ->join('ur.role_rights', 'rr', 'WITH', 'rr.deleteuserId is null and rr.gRight=?1')
                ->leftJoin('u.user_rights', 'ur1', 'WITH', 'ur1.menuId=rr.menuId and ur1.deleteuserId is null')
                ->where('ur1.id is null and u.id=?2')
                ->groupBy('rr.menuId')
                ->setParameter(1, 't')
                ->setParameter(2, $userId)
                ->getQuery();
            //dump($queryrole->getSql());
            $resultrole = $queryrole->getArrayResult();
            //dump($resultrole);
            $queryright = $em->createQueryBuilder()
                ->select("IDENTITY(ur.menuId)menuId"
                        . ",MIN(case when ur.gRight='t' then 1 else 0 end)gRight"
                        . ",MIN(case when ur.aRight='t' then 1 else 0 end)aRight"
                        . ",MIN(case when ur.uRight='t' then 1 else 0 end)uRight"
                        . ",MIN(case when ur.dRight='t' then 1 else 0 end)dRight"
                        . ",MIN(case when ur.uOwnRight='t' then 1 else 0 end)uOwnRight"
                        . ",MIN(case when ur.dOwnRight='t' then 1 else 0 end)dOwnRight"
                        . "")
                ->from('KaitekFrameworkBundle:User','u')
                ->join('u.user_rights', 'ur', 'WITH', 'ur.deleteuserId is null and ur.gRight=?1')
                ->where('u.id=?2')
                ->groupBy('ur.menuId')
                ->setParameter(1, 't')
                ->setParameter(2, $userId)
                ->getQuery();
            //dump($queryright->getSql());
            $resultright = $queryright->getArrayResult();
            //dump($resultright);

            $qb = $em->createQueryBuilder();
            $queryfree = $qb->select(
                        "(m.id)menuId"
                        . ",(1)gRight"
                        . ",(1)aRight"
                        . ",(1)uRight"
                        . ",(1)dRight"
                        . ",(1)uOwnRight"
                        . ",(1)dOwnRight")
                ->from('KaitekFrameworkBundle:Menu','m')
                ->where('m.deleteuserId is null')
                ->andWhere($qb->expr()->in('m.menuId', ':unrestricted'))
                ->setParameter('unrestricted', $this->UNRESTRICTED_MENU_IDS)
                ->getQuery();
            $resultfree = $queryfree->getArrayResult();
            $tmpMenus=array_merge($resultrole, $resultright, $resultfree);
            //dump($tmpMenus);

            if(count($tmpMenus)>0) {
                $ids = implode(',', array_column($tmpMenus, 'menuId'));
                $ids = explode(',', $ids);
                $qb = $em->createQueryBuilder();
                $queryParents = $qb->select(
                        "(m.parentid)menuId"
                        .",(1)gRight"
                        .",(1)aRight"
                        .",(1)uRight"
                        .",(1)dRight"
                        .",(1)uOwnRight"
                        .",(1)dOwnRight")
                    ->from('KaitekFrameworkBundle:Menu', 'm')
                    ->where('m.deleteuserId is null')
                    ->andWhere($qb->expr()->in('m.id', ':ids'))
                    ->setParameter('ids', $ids)
                    ->groupBy('m.parentid')
                    ->getQuery();
                $resultParents = $queryParents->getArrayResult();
                $tmpMenus = array_merge($resultrole, $resultright, $resultfree, $resultParents);
            }

            $result=array();
            if(count($tmpMenus)>0){
                $ids=implode(',', array_column($tmpMenus, 'menuId'));
                $ids=explode(',',$ids);
                //dump($ids);
                $qb = $em->createQueryBuilder();
                $querymenu=$qb->select('m.id,m.sira,m.parentid,m.menuId,m.title,m.url
                                ,m.width,m.height,m.modulename,m.iconcls,m.script
                                ,m.multiplewindow,m.maximizable,m.resizable,m.mobiledevice')
                    ->from('KaitekFrameworkBundle:Menu','m')
                    ->where('m.deleteuserId is null')
                    ->andWhere($qb->expr()->in('m.id', ':ids'))
                    ->orderBy('m.parentid', 'ASC')
                    ->addOrderBy('m.sira', 'ASC')
                    ->setParameter('ids', $ids)
                    ->getQuery();
                //dump($querymenu);
                //dump($querymenu->getSql());
                $querymenu=$querymenu->getArrayResult();
            }else{
                $querymenu=array();
            }
            for($i=0;$i<count($querymenu);$i++){
                $item=$querymenu[$i];
                $key = array_search($item['id'], array_column($tmpMenus, 'menuId'));
                if(false!==$key){
                    $citem=$tmpMenus[$key];
                    unset($citem['menuId']);
                    //unset($citem['gRight']);
                    //dump($citem);
                    //dump($key);
                    $result[]=array_merge($item,$citem);
                }
            }
            //dump($menus);
            return $result;
        }
        if ($ra){
            $query = $this->createQueryBuilder('m')
                ->select('m.id,m.sira,m.parentid,m.menuId,m.title,m.url
                    ,m.width,m.height,m.modulename,m.iconcls,m.script
                    ,m.multiplewindow,m.maximizable,m.resizable,m.mobiledevice
                    ,1 aright,1 uright,1 dright,1 uownright,1 downright')
                ->where('m.deleteuserId is null')
                ->orderBy('m.parentid', 'ASC')
                ->addOrderBy('m.sira', 'ASC')
                ->getQuery();
            $result = $query->getArrayResult();
            return $result;
        }
        return array();
    }

    /**
     * Makes menu records based on the user's rights.
     *
     *
     * @param EntityManager $em
     * @param bool $af IS_AUTHENTICATED_FULLY
     * @param bool $ru ROLE_USER
     * @param bool $ra ROLE_ADMIN
     * @param mixed $tr Translate service
     * @param int $userId User id value
     *
     * @return MenuInterface|null
     */
    public function loadUserMenuQB(EntityManager $em, bool $af, bool $ru, bool $ra, $tr, int $userId){
        $result=$this->loadUserRightMenu($em,$af,$ru,$ra,$tr,$userId);
        /*$menus=array();
        $pid=-1;
        $j=0;
        for($i=0;$i<count($result);$i++){
            $item=$result[$i];
            $modulename=$item['modulename'];
            $title=$item['title'];
            if($modulename==""){
                $arrtitle = explode(".", $title);
                $domain=$arrtitle[0];
                array_shift($arrtitle);
                $key=implode(".", $arrtitle);
            }else{
                $domain=$modulename;
                if($title==""){
                    $key=$modulename.".title";
                }else{
                    $key=$modulename.".".$title;
                }
            }
            $title=$tr->trans($key, array(), $domain);
            $item['title']=$title;
            if($pid!==$item['parentid']){
                $pid=$item['id'];
                $menus[$j++]=$item;
            }else{
                if(!isset($menus[$j-1]['items'])){
                    $menus[$j-1]['items']=array();
                }
                $menus[$j-1]['items'][]=$item;
            }
        }
        return $menus;*/
        return $this->loadUserMenuTree($result,$tr);
    }

    private function _buildTreeData($result, $tr, $text='title', $subitem='items', $parentid){
        $menus = array();
        for($i=0; $i<count($result); $i++){
            $item=$result[$i];
            if($item['parentid'] == $parentid){
                $modulename=$item['modulename'];
                $title=$item['title'];
                if($modulename==""){
                    $arrtitle = explode(".", $title);
                    $domain=$arrtitle[0];
                    array_shift($arrtitle);
                    $key=implode(".", $arrtitle);
                }else{
                    $domain=$modulename;
                    if($title==""){
                        $key=$modulename.".title";
                    }else{
                        $key=$modulename.".".$title;
                    }
                }
                $trTitle = $tr->trans($key, array(), $domain);
                if($trTitle != ""){
                    $title = $trTitle;
                }
                $item[$text]=$title;

                $children = $this->_buildTreeData($result, $tr, $text, $subitem, $item['id']);
                if(count($children)>0){
                    $item['subMenuAlign']='tr';
                    $item[$subitem] = $children;
                }
                $menus[] = $item;
            }
        }
        return $menus;
    }

    private function _buildTreeGridData(&$result, $subitem='items'){
        for($i=0; $i<count($result); $i++){
            $item=$result[$i];
            if(isset($result[$i][$subitem]) && count($result[$i][$subitem])>0){
                $result[$i][$subitem] = $this->_buildTreeGridData($result[$i][$subitem], $subitem);
                unset($result[$i]["role_right_id"]);
            } else {
                $result[$i]["data"] = (object) [
                    "gRight" => $result[$i]["gRight"],
                    "aRight" => $result[$i]["aRight"],
                    "uRight" => $result[$i]["uRight"],
                    "dRight" => $result[$i]["dRight"],
                    "uOwnRight" => $result[$i]["uOwnRight"],
                    "dOwnRight" => $result[$i]["dOwnRight"]
                ];
            }
            unset($result[$i]["gRight"]);
            unset($result[$i]["aRight"]);
            unset($result[$i]["uRight"]);
            unset($result[$i]["dRight"]);
            unset($result[$i]["uOwnRight"]);
            unset($result[$i]["dOwnRight"]);
            unset($result[$i]["title"]);
        }
        return $result;
    }

    public function loadRoleRights($roleId){
        $em = $this->getEntityManager();
        $qb = $em->createQueryBuilder();
        $querymenu=$qb->select("IDENTITY(rr.menuId) id"
                . ",(case when rr.gRight='t' then 1 else 0 end)gRight"
                . ",(case when rr.aRight='t' then 1 else 0 end)aRight"
                . ",(case when rr.uRight='t' then 1 else 0 end)uRight"
                . ",(case when rr.dRight='t' then 1 else 0 end)dRight"
                . ",(case when rr.uOwnRight='t' then 1 else 0 end)uOwnRight"
                . ",(case when rr.dOwnRight='t' then 1 else 0 end)dOwnRight"
                . "")
            ->from('KaitekFrameworkBundle:RoleRight','rr')
            ->where('rr.deleteuserId is null and IDENTITY(rr.role)=:roleId')
            ->setParameter('roleId', $roleId)
            ->getQuery();
        return $querymenu->getArrayResult();
    }

    public function loadUserMenuTree($result, $tr, $text='title', $subitem='items'){
        return $this->_buildTreeData($result, $tr, $text, $subitem, 0);
    }

    public function loadUserMenuTreeWithRoleRights($roleId, $tr, $text='title', $subitem='items'){
        //return $this->_buildTreeData($result, $tr, $text, $subitem, 0);
        $em = $this->getEntityManager();
        $qb = $em->createQueryBuilder();
        $querymenu=$qb->select("m.id,rr.id role_right_id,rr.version,m.sira,m.parentid,m.menuId,m.modulename,m.title"
                . ",(case when rr.gRight='t' then 1 else 0 end)gRight"
                . ",(case when rr.aRight='t' then 1 else 0 end)aRight"
                . ",(case when rr.uRight='t' then 1 else 0 end)uRight"
                . ",(case when rr.dRight='t' then 1 else 0 end)dRight"
                . ",(case when rr.uOwnRight='t' then 1 else 0 end)uOwnRight"
                . ",(case when rr.dOwnRight='t' then 1 else 0 end)dOwnRight"
                . "")
            ->from('KaitekFrameworkBundle:Menu','m')
            ->leftJoin('KaitekFrameworkBundle:RoleRight', 'rr', 'WITH', 'rr.menuId=m.id and rr.deleteuserId is null and IDENTITY(rr.role)=:roleId')
            ->where('m.deleteuserId is null')
            ->andWhere($qb->expr()->notIn('m.menuId', ':unrestricted'))
            ->orderBy('m.parentid', 'ASC')
            ->addOrderBy('m.sira', 'ASC')
            ->setParameter('roleId', $roleId)
            ->setParameter('unrestricted', $this->UNRESTRICTED_MENU_IDS)
            ->getQuery();
        $menus = $querymenu->getArrayResult();
        $treeData = $this->_buildTreeData($menus, $tr, $text, $subitem, 0);
        return $this->_buildTreeGridData($treeData, $subitem, 0);
    }

    public function loadUserMenuTreeWithUserRights($userId, $tr, $text='title', $subitem='items'){
        //return $this->_buildTreeData($result, $tr, $text, $subitem, 0);
        $em = $this->getEntityManager();
        $qb = $em->createQueryBuilder();
        $querymenu=$qb->select("m.id,ur.id user_right_id,ur.version,m.sira,m.parentid,m.menuId,m.modulename,m.title"
                . ",(case when ur.gRight='t' then 1 else 0 end)gRight"
                . ",(case when ur.aRight='t' then 1 else 0 end)aRight"
                . ",(case when ur.uRight='t' then 1 else 0 end)uRight"
                . ",(case when ur.dRight='t' then 1 else 0 end)dRight"
                . ",(case when ur.uOwnRight='t' then 1 else 0 end)uOwnRight"
                . ",(case when ur.dOwnRight='t' then 1 else 0 end)dOwnRight"
                . "")
            ->from('KaitekFrameworkBundle:Menu','m')
            ->leftJoin('KaitekFrameworkBundle:UserRight', 'ur', 'WITH', 'ur.menuId=m.id and ur.deleteuserId is null and ur.userId=:userId')
            ->where('m.deleteuserId is null')
            ->andWhere($qb->expr()->notIn('m.menuId', ':unrestricted'))
            ->orderBy('m.parentid', 'ASC')
            ->addOrderBy('m.sira', 'ASC')
            ->setParameter('userId', $userId)
            ->setParameter('unrestricted', $this->UNRESTRICTED_MENU_IDS)
            ->getQuery();
        $menus = $querymenu->getArrayResult();
        $treeData = $this->_buildTreeData($menus, $tr, $text, $subitem, 0);
        return $this->_buildTreeGridData($treeData, $subitem, 0);
    }

    /**
     * Makes menu records based on the user's rights.
     *
     *
     * @param EntityManager $em
     * @param bool $af IS_AUTHENTICATED_FULLY
     * @param bool $ru ROLE_USER
     * @param bool $ra ROLE_ADMIN
     * @param DataCollectorTranslator|Translator $tr Translate service
     * @param Integer $userId User id value
     * @param Integer $menuId Menu id value
     *
     * @return array|null
     */
    public function loadUserRightMenuQB($em,$af,$ru,$ra,$tr,$userId,$menuId){
        $result=$this->loadUserRightMenu($em,$af,$ru,$ra,$tr,$userId);
        $key = array_search($menuId, array_column($result, 'id'));
        if(false!==$key){
            return $result[$key];
        }
        return null;
    }
}
